#include <conio.h>
#include <math.h>
#include <my\pcx.h>
#include <my\graph.h>
#pragma inline

#define RAD  128      //transz. matr sugara
#define M 100         //nagyitas
#define P 300         //perspektiva

typedef struct
{
 unsigned char x;
 unsigned char y;
} T2d;

T2d transtab[256][256];
char *screen,*texture;


#pragma aux sphr "_*" parm caller [];
void sphr(int cx,int cy,int cz, int a, int b);
#pragma aux cls "_*" parm caller [];
void cls(char *scr);

void tabfill(int r);
void txtr(int x, int y, int z, unsigned char a, unsigned char b);
void getm(void);
void releasem(void);

void main(void)
{
 unsigned char a=0,b=0;
 int n,x,y,z;
 char pal[768];

// getch();
 getm();
 init640X480();
 readpcx("pic.pcx",texture,pal,256,256);
 setpal(pal);
 tabfill(RAD);

 do
 {
//  a=128*sin((float)(4*n/57.3));
  a=60*cos((float)(3*n/57.3)+0.001);
  x=320*sin((float)(3*n/2/57.3))+300;
  y=200*cos((float)(n/57.3+0.001))+180;
  z=300*sin((float)(2*n/57.3))+330;
  cls(screen);
  b+=5;
  sphr(x,y,z,a,b);
//  txtr(x,y,z,a,b);
  disp640X480(screen);
  n++;
 } while (!kbhit());
 getch();

 releasem();
 closegraph();
}

void tabfill(int r)
{
  int x,y,kx;
  float d,tx,ty;
  float z;

  //negyzet alaku textura beletorzitasa egy korbe:
/*  for(y=-RAd;y<RAD;y++)
  {
   tx=0;
   kx=sqrt(r*r-y*y);
   d=RAD/sqrt(r*r-y*y);
   for(x=-kx;x<kx;x++)
   {
    texture
   }
  }*/

  //kor ratorzitasa egy felgombre :
  for(y=-RAD;y<RAD;y++)
  {
   kx=sqrt(r*r-y*y);
   d=RAD/sqrt(r*r-y*y);
   ty=y;
   tx=0;
   for(x=-kx;x<kx;x++)
   {
     tx+=d;
     z=sqrt(-x*x-y*y+r*r);
     transtab[y+RAD][x+RAD].x=r*x/(z+r/2)+RAD;
     transtab[y+RAD][x+RAD].y=r*y/(z+r/2)+RAD;
   }
  }
}

void getm(void)
{
 texture=(char *) malloc(256*256);
 screen=(char *) malloc(640*480);
}

void releasem(void)
{
 free(screen);
 free(texture);
}






void txtr(int cx, int cy, int cz, unsigned char a, unsigned char b)
{
 int d,x,y,n,m,v,z,o,p,l,c;
 char j,k;

 d=cz;
// d=256;
 cx-=256*RAD/d;
 cy-=256*RAD/d;
 cx<<=8;
 cy<<=8;

 for(y=0,m=0;y<256*2*RAD;y+=d,m++)
  for(x=0,n=0;x<256*2*RAD;x+=d,n++)
  {
   v=x>>8;
   z=y>>8;
   o=(cx>>8)+n;
   p=(cy>>8)+m;
   if(transtab[v][z].x!=0 && transtab[v][z].y!=0)
   {
     if(o>0 && o<640 && p>0 && p<480)
     {
      j=transtab[v][z].x+a;
      k=transtab[v][z].y+b;
      c=(k<<8)+j;
      screen[o+p*640]=texture[c];
     }
   }
 }
}

